var updater = null;

/**
 * Everything needed for the auto update function and the update panel.
 */
function Updater() {
	this.clientVersion = null;
	this.updateCheck = true;
	this.lastChecked = null;
	this.url = 'http://xerxes.sofa-rockers.org/versionInfo.php?id=1';
	
	$('#no').bind('mouseover mousedown', function(event) {
		$(event.target).attr('src', 'Images/cancelUpdate_pressed.png');});
	$('#no').bind('mouseout mouseup', function(event) {
		$(event.target).attr('src', 'Images/cancelUpdate.png');});
	$('#no').click(function(event) {
		$('#update').css('display', 'none');});
	$('#yes').bind('mouseover mousedown', function(event) {
		$(event.target).attr('src', 'Images/doUpdate_pressed.png');});
	$('#yes').bind('mouseout mouseup', function(event) {
		$(event.target).attr('src', 'Images/doUpdate.png');});
	$('#yes').click(function(event) {
		if (window.widget)
			widget.openURL('http://xerxes.sofa-rockers.org');
		$('#update').css('display', 'none');
	});
}

/**
 * Check for updates.
 *
 * Currently checks once a day, I have to change it in a later release ...
 */
Updater.prototype.check = function() {
	if (!updater.clientVersion)
		updater.obtainVersion();

	if (updater.updateCheck && (!updater.lastChecked
			|| (new Date()).getDate() != updater.lastChecked.getDate())) {		
		$.ajax({
			url: updater.url,
			type: 'GET',
		 	dataType: 'string',
		  	success: function(remoteVersion) {
				if (remoteVersion > updater.clientVersion)
					$('#update').css('display', 'block');
			}
		});
				
		updater.lastChecked = new Date();
	}
};

/**
 * Obtain the current client version from the Info.plist file and set the
 * value to updater.clientVersion.
 */
Updater.prototype.obtainVersion = function() {
	$.ajax({
		type: "GET",
		url: "Info.plist",
		dataType: "xml",
		success: function(data) {
			updater.clientVersion =
				$('plist > dict > key:contains("CFBundleVersion")', 
					data).next('string').text();
		}
	});
};


